const  dataSource = 'https://gist.githubusercontent.com/Razpudding/f884509f465766aa4ad31e9cf18a696c/raw/3aa25817113f50f0a0695b87fffc4e234ac1c8d0/eyecolor-gender.json'
const svg = d3.select('svg').attr('width','2000px')

d3.json(dataSource)
	.then(data => {
  	data = data.filter(validColor)
		data = data.map(transformColor)
  	data.sort( (a,b) => d3.ascending(a.b, b.b))
		drawMap(data)
})

function drawMap(data){
  console.log("drawmap called with elements", data.length)
  let circles = svg.selectAll(".dot")
    .data(data)
  	.enter()
    .append("circle")
  		.attr("class", "dot")
      .attr("r", 8.5)
      .attr("cx", function(d,i){ console.log(d,i); return i * 20})
      .attr("cy", 30)
  		.attr("fill", d => d.eyeColor)
}

//Check if a color is valid with a regex tester
function validColor(row){
  row.eyeColor = row.eyeColor.toUpperCase()
  //Thanks mohammed
 	return (/^((0x){0,1}|#{0,1})([0-9A-F]{8}|[0-9A-F]{6})$/).test(row.eyeColor) 
}

//Adds r,g,b properties
function transformColor(row){
	if (row.eyeColor != "undefined"){
		row.r = parseInt(row.eyeColor.substring(0,2), 16)
    row.g = parseInt(row.eyeColor.substring(2,4), 16)
    row.b = parseInt(row.eyeColor.substring(4,6), 16)
    row.eyeColor = row.eyeColor.charAt(0) == "#"? row.eyeColor : "#" + row.eyeColor
  }
  //console.log(row)
	return row
}